package blusci;

import processing.core.*; 
import fullscreen.*;  //um im Vollbildmodus starten zu können.

import org.scilab.modules.javasci.Scilab;
import org.scilab.modules.types.ScilabType;
import org.scilab.modules.types.ScilabDouble;

import kiba.hilfsklassen.Dateioperationen;

import kiba.betriebssystem.Linuxsystem;

public class BLUSCI2 extends PApplet
{
    Scilab sci;
    
    int zaehler = 0; //für die Animation des roten Balls
    
    Dateioperationen dateioperationen;
    Linuxsystem linuxsystem;
    
    public void sprich(String text)
    {
        if(linuxsystem!=null)
            linuxsystem.syst("espeak -s100 -k20 -v mb-de7 \""+text+"\"");
        System.out.println(text);            
    }
    
    public void setup()
    {
        dateioperationen = new Dateioperationen();
        linuxsystem      = new Linuxsystem();
        try
        {
            sci = new Scilab();
            sci.open();                                     
        }
        catch(Exception e)
        {
            sprich("Problem beim Öffnen von Scilab:"+e);
            System.exit(0);
        }
       sprich("Animation des roten Balls wird gestartet.");
        size(displayWidth, displayHeight);
        frameRate(20);
        (new FullScreen(this)).enter();         
    }
    
    public void draw()
    {                
        clear();
        fill(0);
        rect(0,0,displayWidth,displayHeight);
        fill(255,0,0);
        if(zaehler<displayWidth/2)
            ellipse(displayWidth/4 + zaehler,120,40,40);
        else
            ellipse(displayWidth/4 + displayWidth - zaehler,120,40,40);
            
        zaehler+=8;
        zaehler%=displayWidth;
    }   
    
    public static void main(String[] passedArgs) 
    {
        String[] appletArgs = new String[] { "blusci.BLUSCI2" };
        if(passedArgs != null) 
        {
             PApplet.main(concat(appletArgs, passedArgs));
        } 
        else 
        {
            PApplet.main(appletArgs);
        }            
    }    
}
