//Vergl. Beispiel optim(..) in der Scilab-Hilfe:
clear();

//function [f, g, ind]=cost(x, ind)
function f=berechneFehler(x)
    ZZ  = [0.    ,   0.;         
           0.074 ,   94.594595;  
           0.133 ,   1271.1864;  
           0.199 ,   1363.6364;  
           0.265 ,   1393.9394];

    p=x(1);
    q=x(2);
    r=x(3);

    s = poly(0,"s");
    G = syslin('c',[1],[p*s*s+q*s+r]); //Definition eines PT2-Übertragungsgliedes

    t = ZZ(:,1)';
    anz=size(t);
    u = 4.0*ones(anz(1),anz(2));  //PWM-Signal hatte den Wert 4.
    y = csim(u,t,G);

    //g = x - x0;
    differenz = y(1,:)' - ZZ(:,2); //Differenz
//    f = 0.5 * norm(differenz)^2;
    f = differenz'*differenz;
endfunction


x0 = [0.0001;0.0001;0.0001];

//[fopt, xopt] = optim(cost, x0);
//[fopt, xopt, gopt] = optim(cost, "b", x0.*0.1, x0.*10.0, x0,"gc")
//[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.1, x0.*10.0, x0,"gc")
//[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler),x0);
[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.001, x0.*1000.0, x0);

//Plot mit optimalen Parametern:
disp(xopt);

ZZ  = [0.    ,   0.;         
       0.074 ,   94.594595;  
       0.133 ,   1271.1864;  
       0.199 ,   1363.6364;  
       0.265 ,   1393.9394];

p=xopt(1);
q=xopt(2);
r=xopt(3);

s = poly(0,"s");
G = syslin('c',[1],[p*s*s+q*s+r]); //Definition eines PT2-Übertragungsgliedes

t = ZZ(:,1)';
anz=size(t);
u = 4.0*ones(anz(1),anz(2));  //PWM-Signal hatte den Wert 4.
y = csim(u,t,G);

plot(t,ZZ(:,2)',t,y(1,:));
