//Vergl. Beispiel optim(..) in der Scilab-Hilfe:
clear();

//function [f, g, ind]=cost(x, ind)
function f=berechneFehler(x)
    ZZ  = [0.    ,   0.;         
           0.074 ,   94.594595;  
           0.133 ,   1271.1864;  
           0.199 ,   1363.6364;  
           0.265 ,   1393.9394];

    a=x(1);
    b=x(2);
    c=x(3);
    d=x(4);

    s = poly(0,"s");
    G = syslin('c',[1],[a*s*s*s+b*s*s+c*s+d]); //Definition eines PT2-Übertragungsgliedes

    t = ZZ(:,1)';
    anz=size(t);
    u = 4.0*ones(anz(1),anz(2));  //PWM-Signal hatte den Wert 4.
    y = csim(u,t,G);

    //g = x - x0;
    differenz = y(1,:)' - ZZ(:,2); //Differenz
    f = 0.5 * norm(differenz)^2;
endfunction


x0 = [0.0001;0.0001;0.0001;0.0001];

//[fopt, xopt] = optim(cost, x0);
//[fopt, xopt, gopt] = optim(cost, "b", x0.*0.1, x0.*10.0, x0,"gc")
//[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.1, x0.*10.0, x0,"gc")
//[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler),x0);
[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.001, x0.*1000.0, x0);


//Plot mit optimalen Parametern:
disp(xopt);

ZZ  = [0.    ,   0.;         
       0.074 ,   94.594595;  
       0.133 ,   1271.1864;  
       0.199 ,   1363.6364;  
       0.265 ,   1393.9394];

a=xopt(1);
b=xopt(2);
c=xopt(3);
d=xopt(4);

s = poly(0,"s");
    G = syslin('c',[1],[a*s*s*s+b*s*s+c*s+d]); //Definition eines PT2-Übertragungsgliedes

t = ZZ(:,1)';
anz=size(t);
u = 4.0*ones(anz(1),anz(2));  //PWM-Signal hatte den Wert 4.
y = csim(u,t,G);

plot(t,ZZ(:,2)',t,y(1,:));


