//Vergl. Beispiel optim(..) in der Scilab-Hilfe:
clear();

//function [f, g, ind]=cost(x, ind)
function f=berechneFehler(x)
ZZ  = [0.           0.         
    0.0294444    37.638991  
    0.0588889    75.277981  
    0.0883333    380.43328  
    0.1177778    967.62128  
    0.1472222    1291.1083  
    0.1766667    1332.3528  
    0.2061111    1366.9014  
    0.2355556    1380.4204  
    0.265        1393.9394];

    p=x(1);
    q=x(2);
    r=x(3);

    s = poly(0,"s");
    G = syslin('c',[1],[p*s*s+q*s+r]); //Definition eines PT2-Übertragungsgliedes

    t = ZZ(:,1)';
    anz=size(t);
    u = 4.0*ones(anz(1),anz(2));  //PWM-Signal hatte den Wert 4.
    y = csim(u,t,G);

    //g = x - x0;
    differenz = y(1,:)' - ZZ(:,2); //Differenz
//    f = 0.5 * norm(differenz)^2;
    f = differenz'*differenz;
endfunction


x0 = [0.0001;0.0001;0.0001];

//[fopt, xopt] = optim(cost, x0);
//[fopt, xopt, gopt] = optim(cost, "b", x0.*0.1, x0.*10.0, x0,"gc")
//[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.1, x0.*10.0, x0,"gc")
//[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler),x0);
[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.001, x0.*1000.0, x0);

//Plot mit optimalen Parametern:
disp(xopt);

ZZ  = [0.           0.         
    0.0294444    37.638991  
    0.0588889    75.277981  
    0.0883333    380.43328  
    0.1177778    967.62128  
    0.1472222    1291.1083  
    0.1766667    1332.3528  
    0.2061111    1366.9014  
    0.2355556    1380.4204  
    0.265        1393.9394];

p=xopt(1);
q=xopt(2);
r=xopt(3);

s = poly(0,"s");
G = syslin('c',[1],[p*s*s+q*s+r]); //Definition eines PT2-Übertragungsgliedes

t = ZZ(:,1)';
anz=size(t);
u = 4.0*ones(anz(1),anz(2));  //PWM-Signal hatte den Wert 4.
y = csim(u,t,G);

plot(t,ZZ(:,2)',t,y(1,:));
