clear();
    ZZ  = [0.    ,   0.;         
           0.074 ,   94.594595;  
           0.133 ,   1271.1864;  
           0.199 ,   1363.6364;  
           0.265 ,   1393.9394;
           1.0   ,   1400.0 ];
    tt=linspace(0,1.0,100);
    ZZZZ = interp1(ZZ(:,1),ZZ(:,2),tt,"linear");
    plot(tt,ZZZZ);
    ZZ = [tt',ZZZZ'];

function f=berechneFehler(x)

    p=x(1);
    q=x(2);
    r=x(3);

    s = poly(0,"s");
    G = syslin('c',[p],[(q+s)*(r+s)]); //...nicht schwingungsfähig!

    t = ZZ(:,1)';
    anz=size(t);
    u = 4.0*ones(anz(1),anz(2));  //PWM-Signal hatte den Wert 4.
    y = csim(u,t,G);

    differenz = y(1,:)' - ZZ(:,2); //Differenz
    f = differenz'*differenz;
endfunction

x0 = [100000.0;20.0;20.0];
[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.001, x0.*1000.0, x0);

//Plot mit optimalen Parametern:
disp(xopt);

p=xopt(1);
q=xopt(2);
r=xopt(3);

s = poly(0,"s");
    G = syslin('c',[p],[(q+s)*(r+s)]); //...nicht schwingungsfähig!

t = ZZ(:,1)';
anz=size(t);
u = 4.0*ones(anz(1),anz(2));  //PWM-Signal hatte den Wert 4.
y = csim(u,t,G);

plot(t,ZZ(:,2)',t,y(1,:));
