package kiba.hilfsklassen;


/**
 * N über k OHNE BERÜCKSICHTIGUNG DER REIHENFOLGE
 * 
 * 
 * Möglichkeiten K aus N auszuwählen, ohne Berücksichtigung der Reihenfolge.
 * Beispiel: Gruppen an Intervallen der Stärke K aus allen möglichen N Intervallen zusammenstellen.
 * 
 */
public class N_ueber_K
{
    public int N;
    public int K;

    public int[] menge;
    
    public int[] auswahl;
    
    public void refreshAuswahl()
    {
        for(int i=0;i<menge.length;i++)
            if(menge[i]>0)        
                auswahl[menge[i]-1]=i;
    }

    
    public long bestimmeAnzahlMoeglichkeiten()
    {
        long anz = 1;
        long kk = 1;
        //    n!/(k!*(n-k)!)
        for(long u=N;u>(N-K);u--)
            anz*=u;
        for(long u=K;u>=2;u--)
            kk*=u;
        return anz/kk;    
    }
    
    public void initialisieren()
    {
        for(int i=0;i<menge.length;i++)
            menge[i]=0;
        for(int i=0;i<K;i++)
            menge[i]=i+1;
            
        refreshAuswahl();            
    }
    
    public N_ueber_K(int N, int K)
    {
        this.N = N;
        this.K = K;
        
        menge = new int[N];
        auswahl = new int[K];
        initialisieren();
    }
    
    public boolean next()
    {
        //Versuchen, einen Eintrag in menge weiter zu verschieben
        //Beginn von hinten
        
        for(int i=menge.length-1;i>=0;i--)
        {
            if(menge[i]>0 && i<menge.length-1 && menge[i+1]==0)
            {
                menge[i+1]=menge[i];
                menge[i]=0;
                int rr=i+2;
                for(int u=menge[i+1]+1;u<=K;u++)
                {
                    if(rr<menge.length)
                    {
                        menge[rr]=u;
                        rr++;
                    }                        
                }        
                for(int u=rr;u<menge.length;u++)
                    menge[u]=0;
                return true;
            }
        }
        return false; //nicht möglich weitere Verschiebungen vorzunehmen
    }
    
    public void showMenge()
    {
        for(int i=0;i<menge.length;i++)
            System.out.print(menge[i]+" ");
    }
    public void showAuswahl()
    {
        for(int i=0;i<auswahl.length;i++)
            System.out.print(auswahl[i]+" ");
    }
    
    public static void main(String[] args)
    {
        N_ueber_K nk = new N_ueber_K(6,3);
        int anzahl = 0;
        
        System.out.println("Anzahl der möglichen Varianten für 6 über 3: "+nk.bestimmeAnzahlMoeglichkeiten());
        
        do
        {
            nk.refreshAuswahl();
            System.out.print("Nr."+anzahl+": ");
            if(anzahl<10) System.out.print(" ");
            if(anzahl<100) System.out.print(" ");
            if(anzahl<1000) System.out.print(" ");
            if(anzahl<10000) System.out.print(" ");
            nk.showMenge();
            System.out.print("   ");    
            nk.showAuswahl();
            System.out.println();    
            anzahl++;
        }while(nk.next());
    
        nk = new N_ueber_K(5,2);
        anzahl = 0;
        
        System.out.println("Anzahl der möglichen Varianten für 5 über 2: "+nk.bestimmeAnzahlMoeglichkeiten());
        
        do
        {
            nk.refreshAuswahl();
            System.out.print("Nr."+anzahl+": ");
            if(anzahl<10) System.out.print(" ");
            if(anzahl<100) System.out.print(" ");
            if(anzahl<1000) System.out.print(" ");
            if(anzahl<10000) System.out.print(" ");
            nk.showMenge();
            System.out.print("   ");    
            nk.showAuswahl();
            System.out.println();    
            anzahl++;
        }while(nk.next());
    }
    
}
