package kiba.hilfsklassen;

/**
 * wie N_ueber_K, aber mit Wiederholungen,
 * z.B. um alle möglichen Intervalle bei mehreren erlaubten Stimmen zu finden.
 */
public class N_ueber_Kwdh
{
    public int N;
    public int K;

    public int[][] menge;
    
    public int[] auswahl;
    
    public void refreshAuswahl()
    {
        for(int k=0;k<menge.length;k++)
          for(int i=0;i<menge[k].length;i++)
            if(menge[k][i]>0)        
                auswahl[k]=i;
    }

    
    public long bestimmeAnzahlMoeglichkeiten()
    {
       initialisieren();
       long anzahl = 0;
       do
       {
           anzahl++;
       } while(next());
       initialisieren();
       return anzahl;
    }
    
    public void initialisieren()
    {
        for(int k=0;k<menge.length;k++)
          for(int i=0;i<menge[k].length;i++)
            menge[k][i]=0;
        for(int k=0;k<menge.length;k++)
            menge[k][0]=1;
            
        refreshAuswahl();            
    }
    
    public N_ueber_Kwdh(int N, int K)
    {
        this.N = N;
        this.K = K;
        
        menge = new int[K][N];
        auswahl = new int[K];
        initialisieren();
    }
    
    public boolean spalteistnull(int[][] matrix, int spalte)
    {
        for(int u=0;u<matrix.length;u++)
            if(matrix[u][spalte]>0)
                return false;
        return true;        
    }
    
    public boolean next()
    {
        //Versuchen, einen Eintrag in menge weiter zu verschieben
        //Beginn von hinten
        
        for(int k=menge.length-1;k>=0;k--)
        {
          for(int i=menge[k].length-1;i>=0;i--)
          {
            if(menge[k][i]>0 && i<menge[k].length-1)// && spalteistnull(menge,i+1))
            {
                menge[k][i+1]=menge[k][i];
                menge[k][i]=0;
                
                for(int p=k+1;p<menge.length;p++)
                    for(int u=0;u<menge[p].length;u++)
                        menge[p][u]=0;
                for(int p=k+1;p<menge.length;p++)
                    menge[p][i+1]=1;                        
                
                return true;
            }
          }
        }
        return false; //nicht möglich weitere Verschiebungen vorzunehmen
    }
    
    public void showAuswahl()
    {
        for(int i=0;i<auswahl.length;i++)
            System.out.print(auswahl[i]+" ");
    }
    
    public static void main(String[] args)
    {
        N_ueber_Kwdh nk = new N_ueber_Kwdh(6,3);
        int anzahl = 0;
        
        System.out.println("Anzahl der möglichen Varianten für 6 über 3 mit Wdh.: "+nk.bestimmeAnzahlMoeglichkeiten());
        
        do
        {
            nk.refreshAuswahl();
            System.out.print("Nr."+anzahl+": ");
            if(anzahl<10) System.out.print(" ");
            if(anzahl<100) System.out.print(" ");
            if(anzahl<1000) System.out.print(" ");
            if(anzahl<10000) System.out.print(" ");
            nk.showAuswahl();
            System.out.println();    
            anzahl++;
        }while(nk.next());
    
        nk = new N_ueber_Kwdh(5,2);
        anzahl = 0;
        
        System.out.println("Anzahl der möglichen Varianten für 5 über 2 mit Wdh.: "+nk.bestimmeAnzahlMoeglichkeiten());
        
        do
        {
            nk.refreshAuswahl();
            System.out.print("Nr."+anzahl+": ");
            if(anzahl<10) System.out.print(" ");
            if(anzahl<100) System.out.print(" ");
            if(anzahl<1000) System.out.print(" ");
            if(anzahl<10000) System.out.print(" ");
            nk.showAuswahl();
            System.out.println();    
            anzahl++;
        }while(nk.next());
    }
    
}
