package kiba.hilfsklassen;


 /**
 *  <h4>Permutation.java</h4>
 *
 *  Copyright (C) 2013 Guido Kramann<br/>
 *  kramann@fh-brandenburg.de<br/>
 *  http://www.kramann.info<br/>
 *  <br/>
 *  <p>  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  </p>
 *  <p>
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  </p>
 *  <p>
 *  You should have received a copy of the GNU General Public License
 *  aint with this program (gpl.html).  If not, see http://www.gnu.org/licenses/.
 *  </p>
 */
public class Permutation
{
    public int stellen;
    public int akt;
    /**
     * Anzahl der möglichen Permutationen:
     */
    public int max;
    
    boolean[] besetzt;
    private int[] zwisch; 
    
    public Permutation(int st)
    {
        stellen = st;
        akt = 0;
        max = st;
        while(st>1)
        {
            st--;
            max*=st;
        }                
        besetzt = new boolean[stellen];        
        zwisch  = new int[stellen-1];
        
    }

    /**
     * Liefert eine ganz bestimmte i-te Permutation:
     */
    public void itePermutation(int akt, int[] erg)
    {
        akt%=max;
        
        for(int i=0;i<besetzt.length;i++)
            besetzt[i]=false;
        for(int i=0;i<erg.length;i++)
            erg[i]=0;
        
        int gesamt = akt;

        for(int i=0;i<stellen-1;i++)
        {
            int pos = gesamt%(i+2);
            zwisch[stellen-2-i]=pos;
            gesamt/=(i+2);
        }

//for(int i=0;i<stellen-1;i++)
//System.out.print(zwisch[i]);
//System.out.println();
        
        for(int i=0;i<stellen-1;i++)
        {
            int k=0;
            int p=0;
            while(k<=zwisch[i])
            {
                while(besetzt[p]==true)
                {
                    p++;
                }
                if(k==zwisch[i])
                {
                    erg[p]=i+1;
                    besetzt[p]=true;
                    break;
                }
                p++;    
                k++;
            }
        }
        
    }
    
    
    /**Liefert die nächste Permutation in der übergebenen Referenz, gibt false zurück,<br/>
    wenn schon die letzte erreicht wurde*/    
    public boolean getNext(int[] erg)
    {
        if(akt>=max)
            return false;

        for(int i=0;i<besetzt.length;i++)
            besetzt[i]=false;
        for(int i=0;i<erg.length;i++)
            erg[i]=0;
        
        int gesamt = akt;

        for(int i=0;i<stellen-1;i++)
        {
            int pos = gesamt%(i+2);
            zwisch[stellen-2-(int)i]=pos;
            gesamt/=(i+2);
        }

//for(int i=0;i<stellen-1;i++)
//System.out.print(zwisch[i]);
//System.out.println();
        
        for(int i=0;i<stellen-1;i++)
        {
            int k=0;
            int p=0;
            while(k<=zwisch[i])
            {
                while(besetzt[p]==true)
                {
                    p++;
                }
                if(k==zwisch[i])
                {
                    erg[p]=i+1;
                    besetzt[p]=true;
                    break;
                }
                p++;    
                k++;
            }
        }
        
        akt++;
        
        return true;
    }
}