package kiba.hilfsklassen;


import java.util.*;

 /**
 *  <h4>Reihenfolge.java</h4>
 *
 *  Copyright (C) 2013 Guido Kramann<br/>
 *  kramann@fh-brandenburg.de<br/>
 *  http://www.kramann.info<br/>
 *  <br/>
 *  <p>  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  </p>
 *  <p>
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  </p>
 *  <p>
 *  You should have received a copy of the GNU General Public License
 *  along with this program (gpl.html).  If not, see http://www.gnu.org/licenses/.
 *  </p>
 */
public class Reihenfolge
{
    public Random random = new Random(System.currentTimeMillis());

    /**
    Liefert eine zufällige Reihenfolge von 0..n-1 ohne Wiederholungen.
    */
    public int[] getReihenfolge(int n)
    {
        int[] folge = new int[n];

        for(int i=0;i<folge.length;i++)
            folge[i] = -1;

        for(int i=0;i<folge.length;i++)
        {
            int stelle = random.nextInt(n);
            for(int k=stelle;k<stelle+n;k++)
            {
                if(folge[k%n]==-1)
                {
                    folge[k%n]=i;
                    break;
                }
            }
        }
        return folge;
    }

    /**
    Liefert eine zufällige Reihenfolge von 0..n-1 ohne Wiederholungen.
    */
    public int[] getReihenfolge(int n,Random random)
    {
        int[] folge = new int[n];

        for(int i=0;i<folge.length;i++)
            folge[i] = -1;

        for(int i=0;i<folge.length;i++)
        {
            int stelle = random.nextInt(n);
            for(int k=stelle;k<stelle+n;k++)
            {
                if(folge[k%n]==-1)
                {
                    folge[k%n]=i;
                    break;
                }
            }
        }
        return folge;
    }


    /**
    Liefert eine zufällige Reihenfolge von 0..n-1 ohne Wiederholungen.<br/>
    Das Ergebnis wird in die Referenz des übergebenen Arrays geschrieben.
    */
    public void getReihenfolge(int[] folge)
    {
        int n=folge.length;

        for(int i=0;i<folge.length;i++)
            folge[i] = -1;

        for(int i=0;i<folge.length;i++)
        {
            int stelle = random.nextInt(n);
            for(int k=stelle;k<stelle+n;k++)
            {
                if(folge[k%n]==-1)
                {
                    folge[k%n]=i;
                    break;
                }
            }
        }
    }


    /**
    Liefert eine zufällige Reihenfolge von 0..n-1 ohne Wiederholungen.<br/>
    Das Ergebnis wird in die Referenz des übergebenen Arrays geschrieben.
    */
    public static void getReihenfolge(int[] folge, Random random)
    {
        int n=folge.length;

        for(int i=0;i<folge.length;i++)
            folge[i] = -1;

        for(int i=0;i<folge.length;i++)
        {
            int stelle = random.nextInt(n);
            for(int k=stelle;k<stelle+n;k++)
            {
                if(folge[k%n]==-1)
                {
                    folge[k%n]=i;
                    break;
                }
            }
        }
    }
}

