package kiba.hilfsklassen;


/**
 *  <h4>Stopuhr.java</h4>
 *
 *  Copyright (C) 2013 Guido Kramann<br/>
 *  kramann@fh-brandenburg.de<br/>
 *  http://www.kramann.info<br/>
 *  <br/>
 *  <p>  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  </p>
 *  <p>
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  </p>
 *  <p>
 *  You should have received a copy of the GNU General Public License
 *  along with this program (gpl.html).  If not, see http://www.gnu.org/licenses/.
 *  </p>
 */
public class Stopuhr
{
    private boolean aktiv = false;
    private long startzeit=0;
    private long endzeit=0;

    /**True, wenn testzeit Millisekunden vergangen sind seit start(), oder
    falls testzeit kleiner ist als endzeit-startzeit, falls bereits gestoppt wurde.*/
    public boolean zeitisterreicht(int testzeit)
    {
        if(aktiv == true && (int)(System.currentTimeMillis() - startzeit)>=testzeit)
            return true;
        if(aktiv == false && (int)(endzeit - startzeit)>=testzeit)
            return true;
            
        return false;        
    }

    /**Seit start() vergangene Anzahl an Millisekunden seit Start oder zwischen start und stop,
    falls bereits gestoppt wurde.*/
    public int getmillis()
    {
        if(aktiv == true)
            return (int)(System.currentTimeMillis() - startzeit);
            
        return (int)(endzeit - startzeit);    
    }

    /**Stopuhr starten*/
    public void start()
    {
        startzeit = System.currentTimeMillis();
        aktiv = true;
    }
    
    /**Stopuhr stoppen.*/
    public void stop()
    {
        endzeit = System.currentTimeMillis(); 
        aktiv = false;
    }
 
    /**Stopuhr resetten.*/   
    public void reset()
    {
        startzeit = 0;
        endzeit   = 0;
        aktiv     = false;
    }    
}

