package kiba.hilfsklassen;


import java.util.Calendar;

 /**
 *  <h4>Zeit.java</h4>
 *
 *  Copyright (C) 2013 Guido Kramann<br/>
 *  kramann@fh-brandenburg.de<br/>
 *  http://www.kramann.info<br/>
 *  <br/>
 *  <p>  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  </p>
 *  <p>
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  </p>
 *  <p>
 *  You should have received a copy of the GNU General Public License
 *  along with this program (gpl.html).  If not, see http://www.gnu.org/licenses/.
 *  </p>
 */
public class Zeit
{
    /**Aktuelle Zeit in Millisekunden*/
    public long millis()
    {
        return System.currentTimeMillis();
    }

    /**Aktuelle Zeit in Sekunden*/
    public long sekunden()
    {
        return System.currentTimeMillis()/1000;
    }

    /**
    Aktuelle Uhrzeit HH_MM_SS
    */
    public String holeUhrzeit()
    {
        Calendar kalender = Calendar.getInstance();         
        String uz = "";
        int h = kalender.get(Calendar.HOUR_OF_DAY);
        int m = kalender.get(Calendar.MINUTE);
        int s = kalender.get(Calendar.SECOND);
        if(h<10)
            uz+="0";
        uz+=h+"_";
        if(m<10)
            uz+="0";
        uz+=m+"_";
        if(s<10)
            uz+="0";
        uz+=s;

        return uz;
    }


    /**Jahr im Format: JJJJ_MM_TT*/
    public String holeDatum()
    {
        long millis = System.currentTimeMillis();
        Calendar kalender = Calendar.getInstance();         
        kalender.setTimeInMillis(millis);
        String datum = "";
        int jahr  = kalender.get(Calendar.YEAR);
        int monat = kalender.get(Calendar.MONTH);
        int tag   = kalender.get(Calendar.DAY_OF_MONTH);
monat++;//da erster 0.

        datum+=jahr;
        datum+="_";

        if(monat<10)
            datum+="0";
        datum+=monat+"_";

        if(tag<10)
            datum+="0";
        datum+=tag+"_";



        return datum;
    }

    /**
    Aktuelle Uhrzeit HH:MM:SS
    */
    public String holeUhrzeitExpire()
    {
        Calendar kalender = Calendar.getInstance();         
        String uz = "";
        int h = kalender.get(Calendar.HOUR_OF_DAY);
        int m = kalender.get(Calendar.MINUTE);
        int s = kalender.get(Calendar.SECOND);
        if(h<10)
            uz+="0";
        uz+=h+":";
        if(m<10)
            uz+="0";
        uz+=m+":";
        if(s<10)
            uz+="0";
        uz+=s;

        return uz;
    }

    /**Jahr im Format: JJJJ:MM:TT*/
    public String holeDatumExpire()
    {
        long millis = System.currentTimeMillis();
        Calendar kalender = Calendar.getInstance();         
        kalender.setTimeInMillis(millis);
        String datum = "";
        int jahr  = kalender.get(Calendar.YEAR);
        int monat = kalender.get(Calendar.MONTH);
        int tag   = kalender.get(Calendar.DAY_OF_MONTH);
monat++;//da erster 0.

        datum+=jahr;
        datum+=":";

        if(monat<10)
            datum+="0";
        datum+=monat+":";

        if(tag<10)
            datum+="0";
        datum+=tag;



        return datum;
    }

}

