package kiba.hilfsklassen;


import java.util.Random;

 /**
 *  <h4>Zufall.java</h4>
 *
 *  Copyright (C) 2013 Guido Kramann<br/>
 *  kramann@fh-brandenburg.de<br/>
 *  http://www.kramann.info<br/>
 *  <br/>
 *  <p>  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  </p>
 *  <p>
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  </p>
 *  <p>
 *  You should have received a copy of the GNU General Public License
 *  along with this program (gpl.html).  If not, see http://www.gnu.org/licenses/.
 *  </p>
 */
public class Zufall
{
    private Random random = null;

    public Zufall()
    {
        random = new Random(System.currentTimeMillis());   
    }

    public Zufall(long seed)
    {
        random = new Random(seed);   
    }

    /**
    Liefert eine Zufallszahl im geschlossenen Intervall<br/>
    [von,bis] (also inklusive bis und von)
    */
    public int next(int von, int bis)
    {
        return random.nextInt(bis-von+1)+von;
    }

    /**
    Liefert eine Zufallszahl im geschlossenen Intervall<br/>
    [von,bis] (also inklusive bis und von)
    */
    public long nextLong(long von, long bis)
    {
        return random.nextLong()%(bis-von)+von;
    }
}

